SystemOrganization addCategory: #'Parasol-Pharo'!

BPPlatform subclass: #BPPharoPlatform
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Parasol-Pharo'!

!BPPharoPlatform class methodsFor: 'class initialization' stamp: 'KrisGybels 8/26/2014 19:55'!
initialize

	super initialize.
! !

!BPPharoPlatform methodsFor: 'facade' stamp: 'haerle 8/19/2014 14:54'!
byteArrayFromBase64String: aString

	^ aString  base64Decoded asByteArray! !

!BPPharoPlatform methodsFor: 'facade' stamp: 'haerle 8/19/2014 14:54'!
fileDelete: filename
	FileDirectory default deleteFileNamed: filename! !

!BPPharoPlatform methodsFor: 'facade' stamp: 'haerle 8/19/2014 14:54'!
fileWrite: filenameString contents: aStringOrByteArray

	| file |
	(file := StandardFileStream forceNewFileNamed: filenameString)
		nextPutAll: aStringOrByteArray;
		close.
	^file fullName! !

!BPPharoPlatform methodsFor: 'facade' stamp: 'haerle 8/20/2014 09:26'!
handleRequest: aBlock

	| response contents|
	response := aBlock value.
	contents := response contents.
	"Carsten Haerle: Why is that necessary? Is it possible to have trailing zeros?  Not not be necessary."
	"contents := contents copyFrom:1 to: (contents findLast: [:c | c asInteger ~= 0 ])."
	^(BPHttpResponse new)
		httpStatus: response status ;
		headers: response headers;
		contents: contents;
		yourself! !

!BPPharoPlatform methodsFor: 'facade' stamp: 'haerle 8/19/2014 14:54'!
httpClient

	"For compatibility with an older version of Zinc:"
	Smalltalk at: #ZnNeoClient ifPresent: [ :class | ^ class new beOneShot; yourself ].
	^ ZnClient new beOneShot; followRedirects: false; yourself.! !

!BPPharoPlatform methodsFor: 'facade' stamp: 'haerle 8/19/2014 14:54'!
httpDelete: url

	^self handleRequest: [ self httpClient url: url; delete; response ]! !

!BPPharoPlatform methodsFor: 'facade' stamp: 'haerle 8/19/2014 14:54'!
httpGet: url

	^self handleRequest: [ self httpClient url: url; get; response ]! !

!BPPharoPlatform methodsFor: 'facade' stamp: 'haerle 8/20/2014 09:26'!
httpPost: url data: data timeout: seconds

	| data2 httpClient response |
	data2 := ZnEntity with: data
				type: (ZnMimeType main: 'application' sub: 'json') setCharSetUTF8.
	httpClient := self httpClient.
	seconds isNil ifFalse: [httpClient timeout: seconds].
	response := httpClient
				url: (ZnUrl fromString: url);
				entity: data2;
				post;
				response.
	^self handleRequest: [ response ]! !

!BPPharoPlatform methodsFor: 'facade' stamp: 'haerle 8/20/2014 09:26'!
isMacOSX
	^ OSPlatform current isMacOSX! !

!BPPharoPlatform methodsFor: 'facade' stamp: 'haerle 8/19/2014 14:54'!
jsonRead: aString 
	^JSJsonParser parse: aString! !

!BPPharoPlatform methodsFor: 'facade' stamp: 'haerle 8/20/2014 09:26'!
jsonWrite: anObject

	^anObject asJson! !

!BPPharoPlatform methodsFor: 'facade' stamp: 'haerle 8/19/2014 14:54'!
name
	^'Pharo'! !

!BPPharoPlatform methodsFor: 'facade' stamp: 'haerle 8/20/2014 09:26'!
pngImageFromByteArray: aByteArray
	^ PNGReadWriter formFromStream: aByteArray readStream.! !

!BPPharoPlatform methodsFor: 'facade' stamp: 'haerle 8/19/2014 14:54'!
port
	^WAAdmin defaultServerManager adaptors first port! !
BPPharoPlatform initialize!
